<?php
/**
 * Plugin Name: Lana Downloads Manager - Abspath Local File Addon
 * Plugin URI: https://lana.codes/product/lana-downloads-manager/
 * Description: Set abspath local file for Lana Downloads Manager.
 * Version: 1.0.0
 * Author: Lana Codes
 * Author URI: http://lana.codes/
 */

defined( 'ABSPATH' ) or die();
define( 'LANA_DOWNLOADS_MANAGER_ABSPATH_LOCAL_FILE_ADDON_VERSION', '1.0.0' );
define( 'LANA_DOWNLOADS_MANAGER_ABSPATH_LOCAL_FILE_ADDON_DIR_URL', plugin_dir_url( __FILE__ ) );
define( 'LANA_DOWNLOADS_MANAGER_ABSPATH_LOCAL_FILE_ADDON_DIR_PATH', plugin_dir_path( __FILE__ ) );

/**
 * Allow abspath local file
 */
add_filter( 'lana_downloads_manager_allow_abspath_local_file', '__return_true' );

/**
 * Forbidden files
 */
function lana_downloads_manager_abspath_local_file_forbidden_files( &$file_path, $remote_file, $local_file ) {
	if ( $local_file ) {
		$filename = wp_basename( parse_url( $file_path, PHP_URL_PATH ) );

		if ( in_array( $filename, array( 'wp-config.php' ) ) ) {
			$file_path = new WP_Error( 'local_file_name_not_allowed', __( 'This local file is not allowed.' ) );
		}
	}
}

add_action( 'lana_downloads_manager_parse_file_path', 'lana_downloads_manager_abspath_local_file_forbidden_files', 10, 3 );
